#ifndef plugin_private_h
#define plugin_private_h 1

/*
  All structures here can change at any time without notice
  and never ever should be used within a plugin directly!
*/

#include "PLU_types.h"

struct Ipo;

struct plugin_uplink_handler {
	void (*gui_draw_slider)(plugin_control_t * control,
				int type, const char* name,
				float def, float min, float max,
				const char* tip, 
				float * data, int xpos, int ypos);

	struct IpoCurve * (*get_icu)(plugin_control_t * control,
				     const char* name);
};

struct IDProperty;

struct plugin_control {
	plugin_type_t plugin_type;         /* plugin type, written to blend */
	char name[64];                     /* written to blend file, to find
					      plugin on reload 
					      This is _not_ the filename, but
					      the name, the plugin used to
					      register itself!
					    */
	plugin_descriptor_t * descriptor;  /* session descriptor pointer */
	plugin_instance_t* instance;       /* session instance pointer */
	struct IDProperty * p_data;        /* written to blend file */
	void * uplink;                     /* session uplink to core structure
					      (Sequence*) e.g. */
	plugin_uplink_handler_t * uplink_handler;
};


#endif
