#ifndef plugin_register_h
#define plugin_register_h

#ifndef PLUGIN_INTERN

static plugin_descriptor_t * plugin_register_video_input(
	const char* name, 
	
	const char* author,
	const char* copyright,
	const char* help,
	const char* date,

	const char* file_pattern,
	
	unsigned long long capabilities,
	
	plugin_private_descriptor_t * desc,

	plugin_instance_t* (*init)(plugin_control_t * c),
	plugin_instance_t* (*load)(plugin_control_t * c),
	void (*free)(plugin_instance_t* This),
	
	struct ImBuf * (*get)(plugin_control_t* c)) {

	plugin_descriptor_t * rv = plugin_register_private(
		B_PLUGIN_VERSION, PLUGIN_TYPE_VIDEO_INPUT,
		capabilities, name, 
		0,
		author,	copyright, help, date, 
		file_pattern, desc, 
		init, load, free);

	rv->i.video_in.get = get;

	return rv;
}

static plugin_descriptor_t * plugin_register_video_effect(
	const char* name, 

	const char* menu_entry,

	const char* author,
	const char* copyright,
	const char* help,
	const char* date,

	unsigned long long capabilities,
	
	plugin_private_descriptor_t * desc,

	plugin_instance_t* (*init)(plugin_control_t * c),
	plugin_instance_t* (*load)(plugin_control_t * c),
	void (*free)(plugin_instance_t* This),
	
	struct ImBuf * (*process)(plugin_control_t* c)) {

	plugin_descriptor_t * rv = plugin_register_private(
		B_PLUGIN_VERSION, PLUGIN_TYPE_VIDEO_EFFECT,
		capabilities, name, 
		menu_entry,
		author,	copyright, help, date, 
		0, desc,
		init, load, free);

	rv->i.video_eff.process = process;

	return rv;
}

#endif

#endif
