/* Copyright (c) 1999, Not a Number / NeoGeo b.v. 
 * $Id: iff.h,v 1.12 2007/01/05 07:35:16 joeedh Exp $
 * 
 * All rights reserved.
 * 
 * Contact:      info@blender.org   
 * Information:  http://www.blender.org
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef IFF_H
#define IFF_H

#include <sys/types.h>
#include "util.h"
#include "externdef.h"

#define IB_rect			(1 << 0)
#define IB_planes		(1 << 1)
#define IB_cmap			(1 << 2)
#define IB_test			(1 << 7)

#define IB_fields		(1 << 11)
#define IB_yuv			(1 << 12)
#define IB_zbuf			(1 << 13)
#define IB_rgba			(1 << 14)

struct ImBuf;

LIBEXPORT struct ImBuf *allocImBuf(short,short,uchar,uint,uchar);
LIBEXPORT struct ImBuf *dupImBuf(struct ImBuf *);
LIBEXPORT void freeImBuf(struct ImBuf*);

LIBEXPORT short converttocmap(struct ImBuf* ibuf);

LIBEXPORT short saveiff(struct ImBuf *,char *,int);

LIBEXPORT struct ImBuf *loadiffmem(int *,int);
LIBEXPORT struct ImBuf *loadifffile(int,int);
LIBEXPORT struct ImBuf *loadiffname(char *,int);
LIBEXPORT struct ImBuf *testiffname(char *,int);

LIBEXPORT struct ImBuf *onehalf(struct ImBuf *);
LIBEXPORT struct ImBuf *onethird(struct ImBuf *);
LIBEXPORT struct ImBuf *halflace(struct ImBuf *);
LIBEXPORT struct ImBuf *half_x(struct ImBuf *);
LIBEXPORT struct ImBuf *half_y(struct ImBuf *);
LIBEXPORT struct ImBuf *double_x(struct ImBuf *);
LIBEXPORT struct ImBuf *double_y(struct ImBuf *);
LIBEXPORT struct ImBuf *double_fast_x(struct ImBuf *);
LIBEXPORT struct ImBuf *double_fast_y(struct ImBuf *);

LIBEXPORT int ispic(char *);

LIBEXPORT void dit2(struct ImBuf *, short, short);
LIBEXPORT void dit0(struct ImBuf *, short, short);

LIBEXPORT unsigned int * IMB_get_rect(struct ImBuf * i);
LIBEXPORT float * IMB_get_rectf(struct ImBuf * i);

LIBEXPORT unsigned int * IMB_get_zbuf(struct ImBuf * i);
LIBEXPORT float * IMB_get_zbuff(struct ImBuf * i);


LIBEXPORT struct ImBuf *scaleImBuf(struct ImBuf *, short, short);
LIBEXPORT struct ImBuf *scalefastImBuf(struct ImBuf *, short, short);
LIBEXPORT struct ImBuf *scalefieldImBuf(struct ImBuf *, short, short);
LIBEXPORT struct ImBuf *scalefastfieldImBuf(struct ImBuf *, short, short);

LIBEXPORT void de_interlace(struct ImBuf *ib);
LIBEXPORT void interlace(struct ImBuf *ib);
LIBEXPORT void gamwarp(struct ImBuf *ibuf, double gamma);

LIBEXPORT void IMB_rectcpy(struct ImBuf *dbuf, struct ImBuf *sbuf, 
	int destx, int desty, int srcx, int srcy, int width, int height);

LIBEXPORT void IMB_rectfill(struct ImBuf *drect, float col[4]);

#endif /* IFF_H */

